/* Test set(), get() and resize() */
#include "common.h"

int main()
{
	GVT(t) a;
	int n;

	auto_init(a);
	print_arr("init ", &a);

	for(n = 0; n < 70; n++) {
		GVT(set)(&a, n, 1);
		print_arr("grow1", &a);
	}

	printf("get1 :");
	for(n = 0; n < 70; n += 10) {
		int *i;
		i = GVT(get)(&a, n, 0);
		printf(" [%d]=%d", n, *i);
	}
	printf("\n");


	GVT(resize)(&a, 35);
	print_arr("shrn1", &a);

	GVT(resize)(&a, 6);
	print_arr("shrn2", &a);

	GVT(resize)(&a, 0);
	print_arr("clean", &a);

	for(n = 0; n < 7; n++) {
		GVT(set)(&a, n*10, (n+1)*10);
		print_arr("grow2", &a);
	}

	printf("get2 :");
	for(n = 0; n < 70; n += 10) {
		int *i;
		i = GVT(get)(&a, n, 0);
		printf(" [%d]=%d", n, *i);
	}
	printf("\n");

	{
		int *i;
		i = GVT(get)(&a, 100, 0);
		printf("get3 : [%d]=%p\n", 100, i);
		print_arr("pget1", &a);
		i = GVT(get)(&a, 100, 1);
		printf("get4 : [%d]=%d\n", 100, *i);
		*i = 42;
		print_arr("pget2", &a);
	}

	GVT(uninit)(&a);
}
